(function () {
    'use strict';

    class Basket extends Laya.Script3D {

        constructor() {
            super();
            this.basket = "";
            this.name = "";
            this.goodsMode = [];
            this.goddsNum = 0;
            this.newNum = 0;
        }

        onEnable() {
            this.basket = this.owner;
            this.name = this.basket.name;

            this.goddsNum = this.basket._children.length;
            this.newNum = this.basket._children.length;
            for (var key in this.basket._children) {
                this.goodsMode.push(this.basket._children[key]);
            }
        }

        // InitName(name) {
        //     this.name = this.basket.name;
        // }

        cutGoods() {
            if (this.newNum > 0) {
                this.newNum--;
                this.basket._children[this.newNum].active = false;
                return this.basket._children[this.newNum].name
            } else {
                return null;
            }
        }

        addGoods() {
            if (this.newNum < this.goddsNum) {
                this.basket._children[this.newNum].active = true;
                this.newNum++;
            }
        }

        reStart() {
            for (var key = this.newNum; key < this.goddsNum; key++) {
                this.basket._children[key].active = true;
                this.newNum++;
            }
        }

        onDisable() {
        }
    }

    class GameData {
        static InitData(successcallback) {
            var playerData = Laya.LocalStorage.getItem("playerData");
            if (playerData) {
                console.log("============老用户============");
                GameData.playerData = JSON.parse(playerData);
                var day = new Date().getDate();
                if (GameData.playerData.curDay != day) {
                    console.log("============新的一天============");
                    GameData.playerData.curDay = day;
                }
            } else {
                console.log("============新用户============");
            }
            Laya.timer.loop(500, this, GameData.AutoSaveData);

            var config = [
                "res/JSON/Level.json",
            ];

            Laya.loader.load(config, Laya.Handler.create(this, function () {
                for (var key in config) {
                    GameData.JSONData = Laya.loader.getRes(config[key]);
                }
                console.log("JSONData:", GameData.JSONData);
                successcallback();
            }));
        }

        static SaveData() {
            var playerData = JSON.stringify(GameData.playerData);
            Laya.LocalStorage.setItem("playerData", playerData);
        }

        static GetData(key) {
            return GameData.playerData[key];
        }

        static SetData(key, value) {
            GameData.playerData[key] = value;
            GameData.AutoSave = true;
        }

        static AutoSaveData() {
            if (GameData.AutoSave) {
                GameData.SaveData();
                GameData.AutoSave = false;
            }
        }

        static getOneJSONData(JSONindex, index) {
            return GameData.JSONData[JSONindex][index];
        }
    }
    GameData.AutoSave = true;//自动保存标识
    GameData.playerData = {
        "yssm": 0,              //隐私声明
        "curDay": 0,            //日期
        "sound": 1
    };
    GameData.JSONData = null;

    class GameManager {
        static OpenSound() {
            Laya.SoundManager.muted = false;
        }

        static CloseSound() {
            Laya.SoundManager.muted = true;
        }

        static PlaySound(name, loop = 1) {
            var sn = "res/Music/" + name + ".mp3";
            Laya.loader.load(sn, Laya.Handler.create(this, () => {
                Laya.SoundManager.playSound(sn, loop);
                if (GameManager.hasPlayedSound.indexOf(sn) == -1) {
                    GameManager.hasPlayedSound.push(sn);
                    Laya.SoundManager.playSound(sn, loop);
                }
            }));
        }

        static PlayMusic(name) {
            Laya.SoundManager.stopAll();
            var sn = "res/Music/" + name + ".mp3";
            Laya.loader.load(sn, Laya.Handler.create(this, () => {
                Laya.SoundManager.playMusic(sn, 0);
                if (GameManager.hasPlayedSound.indexOf(sn) == -1) {
                    GameManager.hasPlayedSound.push(sn);
                    Laya.SoundManager.playMusic(sn, 0);
                }
                if (GameData.GetData("Sound") == 0) {
                    GameManager.CloseSound();
                }
            }));
        }

        static createBasketRay() {
            let point = new Laya.Vector2(0, 0);
            point.x = Laya.MouseManager.instance.mouseX;
            point.y = Laya.MouseManager.instance.mouseY;

            var ray = new Laya.Ray(new Laya.Vector3(0, 0, 0), new Laya.Vector3(0, 0, 0));
            GameManager.Camera.viewportPointToRay(point, ray);
            var outHitRusult = new Laya.HitResult();
            GameManager.resScene.physicsSimulation.rayCast(ray, outHitRusult);
            if (outHitRusult.succeeded) {
                let colliderName = outHitRusult.collider.owner.name;
                if (colliderName.indexOf("Basket") != -1) {
                    return true;
                }
            }
            return false;
        }

        static selectBasketRay() {
            let point = new Laya.Vector2(0, 0);
            point.x = Laya.MouseManager.instance.mouseX;
            point.y = Laya.MouseManager.instance.mouseY;

            var ray = new Laya.Ray(new Laya.Vector3(0, 0, 0), new Laya.Vector3(0, 0, 0));
            GameManager.Camera.viewportPointToRay(point, ray);
            var outHitRusult = [];
            GameManager.resScene.physicsSimulation.rayCastAll(ray, outHitRusult);
            for (var key in outHitRusult) {
                var name = outHitRusult[key].collider.owner.name;
                if (name.indexOf("Basket") != -1 && name.indexOf("BasketPoint") == -1 && name != "Basket") {
                    return name;
                }
            }
            return null;
        }

        static createShowBoxRay() {
            let point = new Laya.Vector2(0, 0);
            point.x = Laya.MouseManager.instance.mouseX;
            point.y = Laya.MouseManager.instance.mouseY;

            var ray = new Laya.Ray(new Laya.Vector3(0, 0, 0), new Laya.Vector3(0, 0, 0));
            GameManager.Camera.viewportPointToRay(point, ray);
            var outHitRusult = new Laya.HitResult();
            GameManager.resScene.physicsSimulation.rayCast(ray, outHitRusult);
            if (outHitRusult.succeeded) {
                let colliderName = outHitRusult.collider.owner.name;
                return colliderName
            }
            return null;
        }

        static createPosRay() {
            let point = new Laya.Vector2(0, 0);
            point.x = Laya.MouseManager.instance.mouseX;
            point.y = Laya.MouseManager.instance.mouseY;

            var ray = new Laya.Ray(new Laya.Vector3(0, 0, 0), new Laya.Vector3(0, 0, 0));
            GameManager.Camera.viewportPointToRay(point, ray);
            var outHitRusult = [];
            GameManager.resScene.physicsSimulation.rayCastAll(ray, outHitRusult);

            return GameManager.showArr(outHitRusult);
        }

        static showArr(outHitArr) {
            GameManager.showBoxPos = [];
            var allName = "";
            for (var key in outHitArr) {
                var name = outHitArr[key].collider.owner.name;
                allName += name + " ";
                if (name.indexOf(GameManager.showBox.name + "_") != -1 && name != GameManager.showBox.name) {
                    GameManager.showBoxPos.push(name);
                }
            }
            if (allName.indexOf(GameManager.showBox.name) == -1 && allName.indexOf("Basket") == -1) {
                if (GameManager.touchTime <= 1) {
                    return "收回"
                } else {
                    return "没有选到任何点位";
                }
            } else {
                if (GameManager.showBoxPos.length > 0) {
                    return GameManager.showBoxPos[GameManager.showBoxPos.length - 1];
                } else {
                    return "没有选到任何点位";
                }
            }
        }

        static searchBasket(goodsName) {
            for (var key in GameManager.Baskets) {
                if (GameManager.Baskets[key].basket._children[0].name == goodsName) {
                    return GameManager.Baskets[key];
                }
            }
            return null;
        }

        static getBoxJS(name) {
            var boxsJS = GameManager.refrigeratorJS.Boxs;
            for (var key in boxsJS) {
                if (boxsJS[key].name == name) {
                    return boxsJS[key];
                }
            }
            return null;
        }

        static checkSuccess() {
            for (var key in GameManager.Baskets) {
                if (GameManager.Baskets[key].newNum != 0) {
                    return false;
                }
            }
            return true;
        }

        static getJSONLength(JSON) {
            var num = 0;
            for (var key in JSON) {
                num++;
            }
            return num;
        }

        static soundName(goodsName) {
            for (var key in GameManager.playSoundName) {
                if (GameManager.playSoundName[key][0] == goodsName) {
                    return GameManager.playSoundName[key][1];
                }
            }
            return null;
        }

        static showAsk(str) {
            Laya.Scene.open("Scene/showAsk.scene", false, str);
        }

    }
    ///////////////////////////////////////////////////////////////////////////////////
    GameManager.Model = null;//预制体
    GameManager.resScene = null;//场景
    GameManager.Scene = null;//场景
    GameManager.Camera = null;
    ///////////////////////////////////////////////////////////////////////////////////
    GameManager.refrigeratorModel = null;
    GameManager.refrigerator = null;
    GameManager.refrigeratorJS = null;
    GameManager.BasketListModel = null;
    GameManager.Baskets = [];
    GameManager.BoxPoint = null;
    GameManager.BoxRotation = null;
    GameManager.showBox = null;
    GameManager.showBoxPos = [];
    GameManager.Covers = [];
    ///////////////////////////////////////////////////////////////////////////////////
    GameManager.GameSceneJS = null;
    ///////////////////////////////////////////////////////////////////////////////////
    GameManager.selectBasket = 0;
    GameManager.selectLevel = 0;
    GameManager.touchTime = 0;
    GameManager.lastShowBoxName = null;
    GameManager.changeMode = true;
    GameManager.hasPlayedSound = [];
    GameManager.isMoving = false;
    GameManager.playSoundName = [["Soda1", "3"], ["Drink1", "3"], ["Drink2", "3"], ["Drink3", "2"], ["Drink4", "2"], ["Coco1", "3"], ["Coco2", "3"], ["Food", "1"], ["IceCream", 2], ["Mars", "1"], ["Meat", "1"], ["Phringles1", "3"], ["Phringles2", "3"], ["Strawbery", "2"]];

    class Cover extends Laya.Script3D {

        constructor() {
            super();
            this.cover = null;
            this.isTriggerEnter = false;
        }

        onEnable() {
            this.cover = this.owner;
        }

        onTriggerStay(other) {
            if (other.owner.name.indexOf("box") == -1 && other.owner.name.indexOf("Refrigerator") == -1 && !GameManager.isMoving) {
                this.isTriggerEnter = true;
            }
        }

        onDisable() {
        }
    }

    class Pos extends Laya.Script3D {

        constructor() {
            super();
            this.pos = null;
            this.name = "";
            this.isEmpty = true;
            this.goods = null;
        }

        onEnable() {
            this.pos = this.owner;
            this.name = this.pos.name;
        }

        addGoods(goods) {
            this.goods = goods;
            var soundName = GameManager.soundName(this.goods.name);
            if (soundName != null) {
                GameManager.PlaySound(soundName);
            }
            this.isEmpty = false;
            if (GameManager.checkSuccess()) {
                if (GameManager.GameSceneJS != null) {
                    GameManager.GameSceneJS.onTriggerIn();
                }
            }
        }

        cutGoods() {
            if (this.goods != null) {
                var goodsName = this.goods.name;
                var basket = GameManager.searchBasket(goodsName);
                if (basket != null) {
                    basket.addGoods();
                }
                this.goods.destroy();
                this.goods = null;
                this.isEmpty = true;
            }
            GameManager.showBox.coverJS.isTriggerEnter = false;
        }

        onDisable() {
        }
    }

    class Box extends Laya.Script3D {

        constructor() {
            super();
            this.box = null;
            this.name = "";
            this.isShow = false;
            this.capacity = 0;
            this.overflow = false;
            this.move = false;
            this.PosArr = [];
            // this.back = true;
            this.cover = null;
            this.coverJS = null;
            this.isFull = false;
        }

        onEnable() {
            this.box = this.owner;
            this.name = this.box.name;
            this.capacity = this.box.getChildByName("box")._children.length;

            this.InitCover();
            this.InitPos();

            this.oldPosition = new Laya.Vector3(this.box.transform.localPosition.x, this.box.transform.localPosition.y, this.box.transform.localPosition.z);
            this.oldRotation = new Laya.Quaternion(this.box.transform.rotation.x, this.box.transform.rotation.y, this.box.transform.rotation.z, this.box.transform.rotation.w);
        }

        InitCover() {
            this.cover = this.box.getChildByName("DB");
            this.coverJS = this.cover.addComponent(Cover);
        }

        InitPos() {
            for (var key in this.box.getChildByName("box")._children) {
                var posJS = this.box.getChildByName("box")._children[key].addComponent(Pos);
                this.PosArr[key] = posJS;
            }
        }

        MoveTo() {
            GameManager.isMoving = true;
            if (this.isShow) {
                this.isShow = false;
                this.moveDistance = new Laya.Vector3(this.oldPosition.x - this.box.transform.position.x, this.oldPosition.y - this.box.transform.position.y, this.oldPosition.z - this.box.transform.position.z);
                this.fromPosition = this.box.transform.position;
                Laya.timer.frameLoop(1, this, this.moveUpdate);
            } else {
                this.isShow = true;
                this.moveDistance = new Laya.Vector3(GameManager.BoxPoint.x - this.box.transform.position.x, GameManager.BoxPoint.y - this.box.transform.position.y, GameManager.BoxPoint.z - this.box.transform.position.z);
                this.fromPosition = this.box.transform.position;
                Laya.timer.frameLoop(1, this, this.moveUpdate);
            }
        }

        MoveOut() {
            this.isShow = true;
            this.moveDistance = new Laya.Vector3(GameManager.BoxPoint.x - this.box.transform.position.x, GameManager.BoxPoint.y - this.box.transform.position.y, GameManager.BoxPoint.z - this.box.transform.position.z);
            this.fromPosition = this.box.transform.position;
            Laya.timer.frameLoop(1, this, this.moveUpdate);
        }

        moveUpdate() {
            let distance = 0;
            var tq = new Laya.Quaternion(0, 0, 0, 1);
            if (this.isShow) {
                distance = Laya.Vector3.distance(this.box.transform.position, GameManager.BoxPoint);
                Laya.Quaternion.slerp(this.box.transform.rotation, GameManager.BoxRotation, 0.1, tq);
            } else {
                distance = Laya.Vector3.distance(this.box.transform.position, this.oldPosition);
                Laya.Quaternion.slerp(this.box.transform.rotation, this.oldRotation, 0.1, tq);
            }
            if (distance < 0.12) {
                Laya.timer.clear(this, this.moveUpdate);
                GameManager.isMoving = false;
                this.reSetFull();
            } else {
                this.box.transform.position = new Laya.Vector3(
                    this.fromPosition.x + (this.moveDistance.x * 0.03),
                    this.fromPosition.y + (this.moveDistance.y * 0.03),
                    this.fromPosition.z + (this.moveDistance.z * 0.03)
                );
            }
            this.box.transform.rotation = tq;
        }

        showPos(name) {
            for (var key in this.PosArr) {
                if (this.PosArr[key].pos.name == name) {
                    return this.PosArr[key]
                }
            }
            return null;
        }

        getRotation() {
            return this.box.transform.rotation;
        }

        onUpdate() {
            if (this.coverJS != null) {
                this.isFull = this.coverJS.isTriggerEnter;
            }
        }

        reSetFull() {
            this.coverJS.isTriggerEnter = false;
        }

        onDisable() {

        }
    }

    class Refrigerator extends Laya.Script3D {

        constructor() {
            super();
            this.refrigerator = null;
            this.name = "";
            this.boxNum = 0;
            this.Boxs = [];
        }

        onTriggerEnter(other) {
            if (other.owner.name == "DB" && GameManager.showBox == null && GameManager.isTrigger) {
                console.log("收回判定:" + other.owner.name);
                if (GameManager.GameSceneJS != null) {
                    GameManager.GameSceneJS.onTriggerOut();
                }
            }
            if (GameManager.GameSceneJS != null) {
                if (GameManager.checkSuccess()) {
                    GameManager.GameSceneJS.showSuccessUI();
                }
            }
        }

        onEnable() {
            this.refrigerator = this.owner;
            this.name = this.refrigerator.name;
            this.InitBox();
        }

        InitBox() {
            if (this.refrigerator != null) {
                var boxModelList = this.refrigerator.getChildByName("box")._children;
                this.boxNum = boxModelList.length;
                console.log("抽屉总数：", this.boxNum);
                for (var key in boxModelList) {
                    var boxModel = boxModelList[key];
                    var boxJS = boxModel.addComponent(Box);
                    this.Boxs.push(boxJS);
                }
            }
        }

        onDisable() {
        }
    }

    class gameScene extends Laya.Scene {

        constructor() {
            super();
            this.deltaX = 0;
            this.lastX = -1;
            this.BasketState = 0;
            this.tempBasketdelta = 0;
        }

        onEnable() {
            GameManager.GameSceneJS = this;
            console.log("进入游戏界面");
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.InitRefrigerator();
            this.InitBasketList();
            this.InitBtn();
            Laya.timer.loop(1, this, this.onUpdate);
            this.settingBtn.visible = false;
        }

        InitRefrigerator() {
            if (GameManager.refrigerator != null) {
                GameManager.refrigerator.destroy();
            }
            GameManager.refrigerator = Laya.Sprite3D.instantiate(GameManager.refrigeratorModel, GameManager.Scene.getChildByName("RefrigeratorPoint"));
            GameManager.refrigeratorJS = GameManager.refrigerator.addComponent(Refrigerator);
            GameManager.refrigerator.transform.position = new Laya.Vector3(0, 0, 0);
            this.BasketState = 1;
            this.tempBasketdelta = 0;
            this.changeSelectType(false);
            GameManager.showBox = null;
            GameManager.isTrigger = false;
        }

        InitBtn() {
            this.settingBtn.on(Laya.Event.CLICK, this, function () {
                this.settingUI.visible = true;
                Laya.stage.off(Laya.Event.MOUSE_DOWN, this, this.showBox);
                Laya.stage.off(Laya.Event.MOUSE_UP, this, this.offSelectBasket);
                Laya.stage.off(Laya.Event.MOUSE_DOWN, this, this.onMouseDown);
                Laya.stage.off(Laya.Event.MOUSE_UP, this, this.onMouseUP);
            });
            this.reStartBtn.on(Laya.Event.CLICK, this, function () {
                this.restartState = true;
                this.settingBtn.visible = false;
                this.reStartBtn.visible = false;
                for (var key in GameManager.Baskets) {
                    GameManager.Baskets[key].reStart();
                }
                this.InitRefrigerator();
            });
            this.settingCloseBtn.on(Laya.Event.CLICK, this, function () {
                this.settingUI.visible = false;
                this.changeSelectType(false);
            });
            if (GameData.GetData("sound") == 1) {
                this.closeMusicBtn.visible = true;
            } else {
                this.closeMusicBtn.visible = false;
            }
            this.closeMusicBtn.on(Laya.Event.CLICK, this, function () {
                this.closeMusicBtn.visible = false;
                GameManager.CloseSound();
                GameData.SetData("sound", 0);
            });
            this.openMusicBtn.on(Laya.Event.CLICK, this, function () {
                this.closeMusicBtn.visible = true;
                GameManager.OpenSound();
                GameData.SetData("sound", 1);
                GameManager.PlayMusic("bgm");
            });
            this.indexBtn.on(Laya.Event.CLICK, this, function () {
                Laya.Scene.open("Scene/mainScene.scene");
            });
            this.continueBtn.on(Laya.Event.CLICK, this, function () {
                Laya.Scene.open("Scene/selectScene.scene", true, true);
            });
        }


        InitBasketList() {
            GameManager.selectBasket = 0;
            GameManager.Baskets = [];
            this.basketArr = GameData.JSONData[GameManager.selectLevel].Basket;
            for (var key in this.basketArr) {
                var bt = GameManager.BasketListModel._children[key];
                var addBasket = GameManager.Model.getChildByName(this.basketArr[key]);
                var BasketModel = Laya.Sprite3D.instantiate(addBasket, bt);
                BasketModel.name = "Basket" + key;
                var BasketJS = BasketModel.addComponent(Basket);
                // BasketJS.InitName("");
                GameManager.Baskets[key] = BasketJS;
                GameManager.Baskets[key].basket.transform.localPosition = new Laya.Vector3(0, 0, 0);
            }
            GameManager.Baskets[GameManager.selectBasket].basket.transform.localScale = new Laya.Vector3(0.8, 0.8, 0.8);
        }

        showBox() {
            if (GameManager.createBasketRay()) {
                this.choseBasket();
                this.lastX = Laya.stage.mouseX;
                Laya.timer.loop(1, this, this.onMoveBasketList);
            } else {
                if (GameManager.showBox == null) {
                    GameManager.showBox = GameManager.getBoxJS(GameManager.createShowBoxRay());
                    if (GameManager.showBox != null) {
                        GameManager.showBox.MoveTo();
                        this.changeSelectType(true);
                    }
                }
            }
        }

        choseBasket() {
            var selectBasketName = GameManager.selectBasketRay();
            if (selectBasketName != null) {
                for (var key in GameManager.Baskets) {
                    if (GameManager.Baskets[key].basket.name == selectBasketName) {
                        GameManager.Baskets[GameManager.selectBasket].basket.transform.localScale = new Laya.Vector3(0.6, 0.6, 0.6);
                        GameManager.Baskets[key].basket.transform.localScale = new Laya.Vector3(0.8, 0.8, 0.8);
                        GameManager.selectBasket = key;
                    }
                }
            }
        }

        onMoveBasketList() {
            this.deltaX = Laya.stage.mouseX - this.lastX;
            this.lastX = Laya.stage.mouseX;
            GameManager.BasketListModel.transform.translate(new Laya.Vector3(0, 0, -this.deltaX * 0.01), true);
        }

        offSelectBasket() {
            Laya.timer.clear(this, this.onMoveBasketList);
        }

        changeSelectType(selectStay) {
            if (selectStay) {
                Laya.stage.off(Laya.Event.MOUSE_DOWN, this, this.showBox);
                Laya.stage.off(Laya.Event.MOUSE_UP, this, this.offSelectBasket);
                Laya.stage.on(Laya.Event.MOUSE_DOWN, this, this.onMouseDown);
                Laya.stage.on(Laya.Event.MOUSE_UP, this, this.onMouseUP);
            } else {
                Laya.stage.off(Laya.Event.MOUSE_DOWN, this, this.onMouseDown);
                Laya.stage.off(Laya.Event.MOUSE_UP, this, this.onMouseUP);
                Laya.stage.on(Laya.Event.MOUSE_DOWN, this, this.showBox);
                Laya.stage.on(Laya.Event.MOUSE_UP, this, this.offSelectBasket);
            }
        }

        onMouseDown() {
            if (GameManager.createBasketRay()) {
                this.choseBasket();
                this.lastX = Laya.stage.mouseX;
                Laya.timer.loop(1, this, this.onMoveBasketList);
            } else {
                Laya.timer.loop(1, this, this.clickPos);
            }
        }

        onMouseUP() {
            GameManager.touchTime = 0;
            Laya.timer.clear(this, this.clickPos);
            Laya.timer.clear(this, this.onMoveBasketList);
            this.deltaX = 0;
        }

        clickPos() {
            GameManager.touchTime++;
            if (GameManager.showBox != null) {
                var chosePos = GameManager.createPosRay();
                if (chosePos == "收回") {
                    this.changeSelectType(false);
                    Laya.timer.clear(this, this.clickPos);
                    GameManager.showBox.MoveTo();
                    GameManager.lastShowBoxName = GameManager.showBox.name;
                    GameManager.showBox = null;
                } else {
                    var posJS = GameManager.showBox.showPos(chosePos);
                    if (posJS != null) {
                        if (posJS.isEmpty) {
                            if (GameManager.touchTime == 1) {
                                GameManager.changeMode = true;
                            }
                        } else {
                            if (GameManager.touchTime == 1) {
                                GameManager.changeMode = false;
                            }
                        }
                        if (GameManager.changeMode) {
                            if (posJS.isEmpty) {
                                var addGoodsName = GameManager.Baskets[GameManager.selectBasket].cutGoods();
                                if (addGoodsName != null) {
                                    var goods = GameManager.Model.getChildByName(addGoodsName);
                                    var goodsModel = Laya.Sprite3D.instantiate(goods, posJS.pos);
                                    goodsModel.transform.localPosition = new Laya.Vector3(0, 0, 0);
                                    goodsModel.transform.rotation = GameManager.showBox.getRotation();
                                    posJS.addGoods(goodsModel);;
                                }
                            }
                        } else {
                            if (!posJS.isEmpty) {
                                posJS.cutGoods();
                            }
                        }
                    }
                }
            }
        }

        onTriggerOut() {
            if (!this.restartState) {
                GameManager.showBox = GameManager.getBoxJS(GameManager.lastShowBoxName);
                if (GameManager.showBox != null) {
                    GameManager.showBox.MoveOut();
                    this.changeSelectType(true);
                    GameManager.showAsk("货物太高无法放入冰箱！");
                    GameManager.touchTime = 0;
                }
            }
        }

        onTriggerIn() {
            this.changeSelectType(false);
            Laya.timer.clear(this, this.clickPos);
            GameManager.showBox.MoveTo();
            GameManager.lastShowBoxName = GameManager.showBox.name;
            GameManager.showBox = null;
        }

        showSuccessUI() {
            Laya.stage.off(Laya.Event.MOUSE_DOWN, this, this.showBox);
            Laya.stage.off(Laya.Event.MOUSE_UP, this, this.offSelectBasket);
            Laya.stage.off(Laya.Event.MOUSE_DOWN, this, this.onMouseDown);
            Laya.stage.off(Laya.Event.MOUSE_UP, this, this.onMouseUP);
            this.successUI.visible = true;
        }

        onUpdate() {
            if (GameManager.showBox != null) {
                GameManager.isTrigger = GameManager.showBox.isFull;
                console.log(GameManager.isTrigger);
            }
            if (this.BasketState == 1) {
                this.tempBasketdelta += 0.1;
                GameManager.BasketListModel.transform.translate(new Laya.Vector3(0.1, 0, 0), true);
                if (this.tempBasketdelta >= 5) {
                    this.BasketState = 2;
                    this.tempBasketdelta = 0;
                }
            } else if (this.BasketState == 2) {
                this.tempBasketdelta += 0.1;
                GameManager.BasketListModel.transform.translate(new Laya.Vector3(-0.1, 0, 0), true);
                if (this.tempBasketdelta >= 5) {
                    this.BasketState = 3;
                    this.tempBasketdelta = 0;
                    this.restartState = false;
                    this.reStartBtn.visible = true;
                    this.settingBtn.visible = true;
                }
            }
        }

        onDisable() {
            GameManager.GameSceneJS = null;
            GameManager.Scene.destroy();
            GameManager.Scene = null;
            Laya.stage.off(Laya.Event.MOUSE_DOWN, this, this.showBox);
            Laya.stage.off(Laya.Event.MOUSE_UP, this, this.offSelectBasket);
            Laya.stage.off(Laya.Event.MOUSE_DOWN, this, this.onMouseDown);
            Laya.stage.off(Laya.Event.MOUSE_UP, this, this.onMouseUP);
        }
    }

    class SDK_apk {
        static goToMoreGame() {
            if (window.android) {
                window.android.goToMoreGame();
            }
        }

        static showYSSM() {
            if (window.android) {
                window.android.showYSSM();
            }
        }

        static showEmail() {
            if (window.android) {
                window.android.showEmail();
            }
        }

        static showNotice() {
            if (window.android) {
                window.android.showNotice();
            }
        }

        static getLogoUrl() {
            if (window.android) {
                SDK_apk.logoUrl = window.android.getLogoUrl();
                console.log("logo地址：" + SDK_apk.logoUrl);
            }
        }

        static getJPGUrl_loading(index) {
            if (window.android) {
                SDK_apk.JPGUrl_loading = window.android.getJPGUrl_loading(index);
                console.log("JPGUrl_loading地址：" + SDK_apk.JPGUrl_loading);
                return SDK_apk.JPGUrl_loading
            }
        }

        static getJPGUrl_main(index) {
            if (window.android) {
                SDK_apk.logoUrl_main = window.android.getJPGUrl_main(index);
                console.log("logoUrl_main地址：" + SDK_apk.logoUrl_main);
                return SDK_apk.logoUrl_main;
            }
        }

        static getJPGNum_loading() {
            if (window.android) {
                return window.android.getJPGNum_loading();
            }
        }

        static getJPGNum_main() {
            if (window.android) {
                return window.android.getJPGNum_main();
            }
        }

        static random(min, max) {
            return Math.floor(Math.random() * (max + 1 - min)) + min;
        }
    }
    SDK_apk.logoUrl = null;
    SDK_apk.JPGUrl_loading = null;
    SDK_apk.logoUrl_main = null;

    class loadingScene extends Laya.Scene {
        constructor() {
            super();
        }

        onEnable() {
            if (window.android) {
                var jpgIndex = SDK_apk.random(0, SDK_apk.getJPGNum_loading() - 1);
                console.log("jpgIndex:" + jpgIndex);
                var JPGbg = new Laya.Image(SDK_apk.getJPGUrl_loading(jpgIndex));
                JPGbg.zOrder = -1;
                JPGbg.centerX = 0;
                JPGbg.centerY = 0;
                this.addChild(JPGbg);
            }

            this.width = Laya.stage.width;
            this.height = Laya.stage.height;

            this.loadValue = 1;
            this.updateLoadValue = 0;
            Laya.timer.loop(1, this, this.update);
        }

        update() {
            this.updateLoadValue += 0.01;
            if (this.updateLoadValue > this.loadValue) {
                this.updateLoadValue = this.loadValue;
            }
            this.loadBar.value = this.updateLoadValue;

            if (this.loadBar.value >= 1) {
                Laya.timer.clear(this, this.update);

                this.loadStr.text = "正在加载数据";
                GameData.InitData(function () {
                    Laya.Scene.open("Scene/mainScene.scene");
                });
            }
        }

        onDisable() {
        }
    }

    class mainScene extends Laya.Scene {

        constructor() {
            super();
        }

        onEnable() {
            if (window.android) {
                this.logo.skin = SDK_apk.logoUrl;

                var jpgIndex = SDK_apk.random(0, SDK_apk.getJPGNum_main() - 1);
                console.log("jpgIndex:" + jpgIndex);
                var JPGbg = new Laya.Image(SDK_apk.getJPGUrl_main(jpgIndex));
                JPGbg.zOrder = -1;
                JPGbg.centerX = 0;
                JPGbg.centerY = 0;
                this.addChild(JPGbg);
            }

            console.log("进入主页面");
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;

            this.startBtn.on(Laya.Event.CLICK, this, this.clickStart);
            this.ageBtn.on(Laya.Event.CLICK, this, function () {
                SDK_apk.showNotice();
            });

            GameManager.PlayMusic("bgm");
        }

        clickStart() {
            Laya.Scene.open("Scene/selectScene.scene");
        }

        onDisable() {
        }
    }

    class selectScene extends Laya.Scene {

        constructor() {
            super();
        }

        onEnable() {
            console.log("进入关卡选择");
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;

            this.loadValue = 0;
            this.updateLoadValue = 0;

            this.InitSelectBtn();

            this.indexBtn.on(Laya.Event.CLICK, this, function () {
                Laya.Scene.open("Scene/mainScene.scene");
            });
        }

        onOpened(AutoLoading = false) {
            var jsonNum = GameManager.getJSONLength(GameData.JSONData);
            if (AutoLoading && GameManager.selectLevel < jsonNum) {
                GameManager.selectLevel++;
                this.selectBtn(GameManager.selectLevel);
            }
        }

        InitSelectBtn() {
            this.selectBtnUI.vScrollBarSkin = "";
            this.selectBtnUI.renderHandler = new Laya.Handler(this, this.updateSelectBtn);
            this.selectBtnUI.array = [];

            let array = [];
            for (var key in GameData.JSONData) {
                let obj = {};
                obj['btn'] = { label: GameData.JSONData[key].name };
                obj['btnID'] = { text: key };
                obj['levelPic'] = { skin: "select/" + key + ".png" };
                array.push(obj);
            }
            this.selectBtnUI.array = array;
        }

        updateSelectBtn(cell) {
            let id = cell.getChildByName("btnID").text;
            let btn = cell.getChildByName("btn");
            btn.offAll();
            btn.on(Laya.Event.CLICK, this, this.selectBtn, [id]);
        }

        selectBtn(id) {
            GameManager.selectLevel = id;
            this.loadingGameUI.visible = true;
            Laya.timer.loop(1, this, this.update);
            this.loadScene();
        }

        loadScene() {
            this.resource = [
                "res/Unity/LayaScene_BX_Scene/Conventional/BX_Scene.ls",
                "res/Unity/LayaScene_BX_Object/Conventional/BX_Object.lh",
            ];
            Laya.loader.create(this.resource, Laya.Handler.create(this, this.onPreLoadFinish),
                Laya.Handler.create(this, function (value) {
                    this.loadValue = value;
                })
            );
        }

        onPreLoadFinish() {
            GameManager.resScene = Laya.Loader.getRes("res/Unity/LayaScene_BX_Scene/Conventional/BX_Scene.ls");
            GameManager.Model = Laya.Loader.getRes("res/Unity/LayaScene_BX_Object/Conventional/BX_Object.lh");
            GameManager.Scene = Laya.stage.addChildAt(GameManager.resScene, 0);
            GameManager.Camera = GameManager.Scene.getChildByName("Main Camera");
            GameManager.BoxPoint = GameManager.Scene.getChildByName("BoxPoint").transform.localPosition;
            GameManager.BoxRotation = GameManager.Scene.getChildByName("BoxPoint").transform.rotation;
            GameManager.BasketListModel = GameManager.Scene.getChildByName("Basket");
            GameManager.refrigeratorModel = GameManager.Model.getChildByName(GameData.JSONData[GameManager.selectLevel].refrigerator);
        }

        update() {
            this.updateLoadValue += 0.01;
            if (this.updateLoadValue > this.loadValue) {
                this.updateLoadValue = this.loadValue;
            }
            this.loadBar.value = this.updateLoadValue;
            if (this.loadBar.value >= 1) {
                Laya.timer.clear(this, this.update);
                Laya.Scene.open("Scene/gameScene.scene");
            }
        }

        onDisable() {

        }
    }

    class showAsk extends Laya.Scene {
        constructor() {
            super();
        }

        onEnable() {
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;

            this.zOrder = 999;
            setTimeout(() => {
                this.destroy();
            }, 1000);
        }

        onOpened(str) {
            this.askStr.text = str;
        }

        onDisable() {
        }
    }

    /**This class is automatically generated by LayaAirIDE, please do not make any modifications. */

    class GameConfig {
        static init() {
            //注册Script或者Runtime引用
            let reg = Laya.ClassUtils.regClass;
    		reg("script/gameScene.js",gameScene);
    		reg("script/loadingScene.js",loadingScene);
    		reg("script/mainScene.js",mainScene);
    		reg("script/selectScene.js",selectScene);
    		reg("script/showAsk.js",showAsk);
        }
    }
    GameConfig.width = 720;
    GameConfig.height = 1280;
    GameConfig.scaleMode ="fixedheight";
    GameConfig.screenMode = "vertical";
    GameConfig.alignV = "middle";
    GameConfig.alignH = "center";
    GameConfig.startScene = "Scene/loadingScene.scene";
    GameConfig.sceneRoot = "";
    GameConfig.debug = false;
    GameConfig.stat = false;
    GameConfig.physicsDebug = false;
    GameConfig.exportSceneToJson = true;

    GameConfig.init();

    class Main {
    	constructor() {
    		SDK_apk.getLogoUrl();

    		//根据IDE设置初始化引擎		
    		if (window["Laya3D"]) Laya3D.init(GameConfig.width, GameConfig.height);
    		else Laya.init(GameConfig.width, GameConfig.height, Laya["WebGL"]);
    		Laya["Physics"] && Laya["Physics"].enable();
    		Laya["DebugPanel"] && Laya["DebugPanel"].enable();
    		Laya.stage.scaleMode = GameConfig.scaleMode;
    		Laya.stage.screenMode = GameConfig.screenMode;
    		Laya.stage.alignV = GameConfig.alignV;
    		Laya.stage.alignH = GameConfig.alignH;
    		//兼容微信不支持加载scene后缀场景
    		Laya.URL.exportSceneToJson = GameConfig.exportSceneToJson;

    		//打开调试面板（通过IDE设置调试模式，或者url地址增加debug=true参数，均可打开调试面板）
    		if (GameConfig.debug || Laya.Utils.getQueryString("debug") == "true") Laya.enableDebugPanel();
    		if (GameConfig.physicsDebug && Laya["PhysicsDebugDraw"]) Laya["PhysicsDebugDraw"].enable();
    		if (GameConfig.stat) Laya.Stat.show();
    		Laya.alertGlobalError(true);

    		//激活资源版本控制，version.json由IDE发布功能自动生成，如果没有也不影响后续流程
    		Laya.ResourceVersion.enable("version.json", Laya.Handler.create(this, this.onVersionLoaded), Laya.ResourceVersion.FILENAME_VERSION);
    	}

    	onVersionLoaded() {
    		//激活大小图映射，加载小图的时候，如果发现小图在大图合集里面，则优先加载大图合集，而不是小图
    		Laya.AtlasInfoManager.enable("fileconfig.json", Laya.Handler.create(this, this.onConfigLoaded));
    	}

    	onConfigLoaded() {
    		//加载IDE指定的场景
    		GameConfig.startScene && Laya.Scene.open(GameConfig.startScene);
    	}
    }
    //激活启动类
    new Main();

}());
